--- old/usr/src/lib/libc/port/locale/setrunelocale.c	Tue May 20 07:58:50 2014
+++ new/usr/src/lib/libc/port/locale/setrunelocale.c	Tue May 20 07:58:50 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -45,208 +46,104 @@
 #include "mblocal.h"
 #include "setlocale.h"
 #include "_ctype.h"
-#include "../i18n/_locale.h"
+#include "lctype.h"
+#include "localeimpl.h"
 
-extern _RuneLocale	*_Read_RuneMagi(FILE *);
-extern unsigned char	__ctype_C[];
+extern _RuneLocale	*_Read_RuneMagi(const char *);
 
-static int		__setrunelocale(const char *);
+struct lc_ctype lc_ctype_posix = {
+	.lc_mbrtowc = __mbrtowc_ascii,
+	.lc_mbsinit = __mbsinit_ascii,
+	.lc_mbsnrtowcs = __mbsnrtowcs_ascii,
+	.lc_wcrtomb = __wcrtomb_ascii,
+	.lc_wcsnrtombs = __wcsnrtombs_ascii,
+	.lc_is_ascii = 1,
+	.lc_max_mblen = 1,
+	.lc_trans_upper = _DefaultRuneLocale.__mapupper,
+	.lc_trans_lower = _DefaultRuneLocale.__maplower,
+	.lc_ctype_mask = _DefaultRuneLocale.__runetype,
+};
 
-static int
-__setrunelocale(const char *encoding)
-{
-	FILE *fp;
-	char name[PATH_MAX];
-	_RuneLocale *rl;
-	int saverr, ret;
-	size_t (*old__mbrtowc)(wchar_t *_RESTRICT_KYWD,
-	    const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
-	size_t (*old__wcrtomb)(char *_RESTRICT_KYWD, wchar_t,
-	    mbstate_t *_RESTRICT_KYWD);
-	int (*old__mbsinit)(const mbstate_t *);
-	size_t (*old__mbsnrtowcs)(wchar_t *_RESTRICT_KYWD,
-	    const char **_RESTRICT_KYWD, size_t, size_t,
-	    mbstate_t *_RESTRICT_KYWD);
-	size_t (*old__wcsnrtombs)(char *_RESTRICT_KYWD,
-	    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
-	    mbstate_t *_RESTRICT_KYWD);
-	static char ctype_encoding[ENCODING_LEN + 1];
-	static _RuneLocale *CachedRuneLocale;
-	static size_t (*Cached__mbrtowc)(wchar_t *_RESTRICT_KYWD,
-	    const char *_RESTRICT_KYWD, size_t, mbstate_t *_RESTRICT_KYWD);
-	static size_t (*Cached__wcrtomb)(char *_RESTRICT_KYWD, wchar_t,
-	    mbstate_t *_RESTRICT_KYWD);
-	static int (*Cached__mbsinit)(const mbstate_t *);
-	static size_t (*Cached__mbsnrtowcs)(wchar_t *_RESTRICT_KYWD,
-	    const char **_RESTRICT_KYWD, size_t, size_t,
-	    mbstate_t *_RESTRICT_KYWD);
-	static size_t (*Cached__wcsnrtombs)(char *_RESTRICT_KYWD,
-	    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
-	    mbstate_t *_RESTRICT_KYWD);
+struct locdata __posix_ctype_locdata = {
+	.l_lname = "C",
+	.l_refcnt = (uint32_t)-1,
+	.l_data = { &lc_ctype_posix, &_DefaultRuneLocale }
+};
 
-	/*
-	 * The "C" and "POSIX" locale are always here.
-	 */
-	if (strcmp(encoding, "C") == 0 || strcmp(encoding, "POSIX") == 0) {
-		int i;
 
-		(void) memcpy(__ctype, __ctype_C, SZ_TOTAL);
+/*
+ * Table of initializers for encodings.  When you add a new encoding type,
+ * this table should be updated.
+ */
+static struct {
+	const char *e_name;
+	void (*e_init)(struct lc_ctype *);
+} encodings[] = {
+	{ "NONE", _none_init },
+	{ "UTF-8",	_UTF8_init },
+	{ "EUC-CN",	_EUC_CN_init },
+	{ "EUC-JP",	_EUC_JP_init },
+	{ "EUC-KR",	_EUC_KR_init },
+	{ "EUC-TW",	_EUC_TW_init },
+	{ "GB18030",	_GB18030_init },
+	{ "GB2312",	_GB2312_init },
+	{ "GBK",	_GBK_init },
+	{ "BIG5",	_BIG5_init },
+	{ "MSKanji",	_MSKanji_init },
+	{ NULL,		NULL }
+};
 
-		for (i = 0; i < _CACHED_RUNES; i++) {
-			__ctype_mask[i] = _DefaultRuneLocale.__runetype[i];
-			__trans_upper[i] = _DefaultRuneLocale.__mapupper[i];
-			__trans_lower[i] = _DefaultRuneLocale.__maplower[i];
-		}
 
-		(void) _none_init(&_DefaultRuneLocale);
-		return (0);
-	}
+struct locdata *
+__lc_ctype_load(const char *name)
+{
+	struct locdata *ldata;
+	struct lc_ctype *lct;
+	_RuneLocale *rl;
+	int i;
+	char path[PATH_MAX];
 
+	if ((ldata = __locdata_alloc(name, sizeof (*lct))) == NULL)
+		return (NULL);
+	lct = ldata->l_data[0];
 	/*
-	 * If the locale name is the same as our cache, use the cache.
-	 */
-	if (CachedRuneLocale != NULL &&
-	    strcmp(encoding, ctype_encoding) == 0) {
-		_CurrentRuneLocale = CachedRuneLocale;
-		__mbrtowc = Cached__mbrtowc;
-		__mbsinit = Cached__mbsinit;
-		__mbsnrtowcs = Cached__mbsnrtowcs;
-		__wcrtomb = Cached__wcrtomb;
-		__wcsnrtombs = Cached__wcsnrtombs;
-		return (0);
-	}
-
-	/*
 	 * Slurp the locale file into the cache.
 	 */
 
-	(void) snprintf(name, sizeof (name), "%s/%s/LC_CTYPE/LCL_DATA",
-	    _PathLocale, encoding);
+	(void) snprintf(path, sizeof (path), "%s/%s/LC_CTYPE/LCL_DATA",
+	    _PathLocale, name);
 
-	if ((fp = fopen(name, "r")) == NULL)
-		return (errno == 0 ? ENOENT : errno);
-
-	if ((rl = _Read_RuneMagi(fp)) == NULL) {
-		saverr = (errno == 0 ? EINVAL : errno);
-		(void) fclose(fp);
-		return (saverr);
+	if ((rl = _Read_RuneMagi(path)) == NULL) {
+		__locdata_release(ldata);
+		errno = EINVAL;
+		return (NULL);
 	}
-	(void) fclose(fp);
+	ldata->l_data[1] = rl;
 
-	old__mbrtowc = __mbrtowc;
-	old__mbsinit = __mbsinit;
-	old__mbsnrtowcs = __mbsnrtowcs;
-	old__wcrtomb = __wcrtomb;
-	old__wcsnrtombs = __wcsnrtombs;
+	lct->lc_mbrtowc = NULL;
+	lct->lc_mbsinit = NULL;
+	lct->lc_mbsnrtowcs = NULL;
+	lct->lc_wcrtomb = NULL;
+	lct->lc_wcsnrtombs = NULL;
+	lct->lc_ctype_mask = rl->__runetype;
+	lct->lc_trans_upper = rl->__mapupper;
+	lct->lc_trans_lower = rl->__maplower;
 
-	__mbrtowc = NULL;
-	__mbsinit = NULL;
-	__mbsnrtowcs = __mbsnrtowcs_std;
-	__wcrtomb = NULL;
-	__wcsnrtombs = __wcsnrtombs_std;
-
-	if (strcmp(rl->__encoding, "NONE") == 0)
-		ret = _none_init(rl);
-	else if (strcmp(rl->__encoding, "UTF-8") == 0)
-		ret = _UTF8_init(rl);
-	else if (strcmp(rl->__encoding, "EUC-CN") == 0)
-		ret = _EUC_CN_init(rl);
-	else if (strcmp(rl->__encoding, "EUC-JP") == 0)
-		ret = _EUC_JP_init(rl);
-	else if (strcmp(rl->__encoding, "EUC-KR") == 0)
-		ret = _EUC_KR_init(rl);
-	else if (strcmp(rl->__encoding, "EUC-TW") == 0)
-		ret = _EUC_TW_init(rl);
-	else if (strcmp(rl->__encoding, "GB18030") == 0)
-		ret = _GB18030_init(rl);
-	else if (strcmp(rl->__encoding, "GB2312") == 0)
-		ret = _GB2312_init(rl);
-	else if (strcmp(rl->__encoding, "GBK") == 0)
-		ret = _GBK_init(rl);
-	else if (strcmp(rl->__encoding, "BIG5") == 0)
-		ret = _BIG5_init(rl);
-	else if (strcmp(rl->__encoding, "MSKanji") == 0)
-		ret = _MSKanji_init(rl);
-	else
-		ret = EINVAL;
-
-	if (ret == 0) {
-		if (CachedRuneLocale != NULL) {
-			free(CachedRuneLocale);
+	/* set up the function pointers */
+	for (i = 0; encodings[i].e_name != NULL; i++) {
+		int l = strlen(encodings[i].e_name);
+		if ((strncmp(rl->__encoding, encodings[i].e_name, l) == 0) &&
+		    (rl->__encoding[l] == '\0' || rl->__encoding[l] == '@')) {
+			encodings[i].e_init(lct);
+			break;
 		}
-		CachedRuneLocale = _CurrentRuneLocale;
-		Cached__mbrtowc = __mbrtowc;
-		Cached__mbsinit = __mbsinit;
-		Cached__mbsnrtowcs = __mbsnrtowcs;
-		Cached__wcrtomb = __wcrtomb;
-		Cached__wcsnrtombs = __wcsnrtombs;
-		(void) strcpy(ctype_encoding, encoding);
-
-		/*
-		 * We need to overwrite the _ctype array.  This requires
-		 * some finagling.  This is because references to it may
-		 * have been baked into applications.
-		 *
-		 * Note that it is interesting that toupper/tolower only
-		 * produce defined results when the input is representable
-		 * as a byte.
-		 */
-
-		/*
-		 * The top half is the type mask array.  Because we
-		 * want to support both legacy Solaris code (which have
-		 * mask valeus baked in to them), and we want to be able
-		 * to import locale files from other sources (FreeBSD)
-		 * which probably uses different masks, we have to perform
-		 * a conversion here.  Ugh.  Note that the _CTYPE definitions
-		 * we use from FreeBSD are richer than the Solaris legacy.
-		 *
-		 * We have to cope with these limitations though, because the
-		 * inadequate Solaris definitions were baked into binaries.
-		 */
-		for (int i = 0; i < _CACHED_RUNES; i++) {
-			/* ctype can only encode the lower 8 bits. */
-			__ctype[i+1] = rl->__runetype[i] & 0xff;
-			__ctype_mask[i] = rl->__runetype[i];
-		}
-
-		/* The bottom half is the toupper/lower array */
-		for (int i = 0; i < _CACHED_RUNES; i++) {
-			__ctype[258 + i] = i;
-			if (rl->__mapupper[i] && rl->__mapupper[i] != i)
-				__ctype[258+i] = rl->__mapupper[i];
-			if (rl->__maplower[i] && rl->__maplower[i] != i)
-				__ctype[258+i] = rl->__maplower[i];
-
-			/* Don't forget these annoyances either! */
-			__trans_upper[i] = rl->__mapupper[i];
-			__trans_lower[i] = rl->__maplower[i];
-		}
-
-		/*
-		 * Note that we expect the init code will have populated
-		 * the CSWIDTH array (__ctype[514-520]) properly.
-		 */
-	} else {
-		__mbrtowc = old__mbrtowc;
-		__mbsinit = old__mbsinit;
-		__mbsnrtowcs = old__mbsnrtowcs;
-		__wcrtomb = old__wcrtomb;
-		__wcsnrtombs = old__wcsnrtombs;
-		free(rl);
 	}
+	if (encodings[i].e_name == NULL) {
+		__locdata_release(ldata);
+		errno = EINVAL;
+		return (NULL);
+	}
 
-	return (ret);
-}
 
-int
-__wrap_setrunelocale(const char *locale)
-{
-	int ret = __setrunelocale(locale);
-
-	if (ret != 0) {
-		errno = ret;
-		return (_LDP_ERROR);
-	}
-	return (_LDP_LOADED);
+	return (ldata);
 }
--- /dev/null	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/strcasecmp.c	Tue May 20 07:58:51 2014
@@ -0,0 +1,74 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+/*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+/*
+ * Portions of this source code were derived from Berkeley 4.3 BSD
+ * under license from the Regents of the University of California.
+ */
+
+#include "lint.h"
+#include <sys/types.h>
+#include <strings.h>
+#include <ctype.h>
+#include <locale.h>
+#include "localeimpl.h"
+#include "lctype.h"
+
+int
+strcasecmp_l(const char *s1, const char *s2, locale_t loc)
+{
+	extern int ascii_strcasecmp(const char *s1, const char *s2);
+	const int *cm;
+	const uchar_t *us1;
+	const uchar_t *us2;
+	const struct lc_ctype *lct = loc->ctype;
+
+	/*
+	 * If we are in a locale that uses the ASCII character set
+	 * (C or POSIX), use the fast ascii_strcasecmp() function.
+	 */
+	if (lct->lc_is_ascii)
+		return (ascii_strcasecmp(s1, s2));
+
+	cm = lct->lc_trans_lower;
+	us1 = (const uchar_t *)s1;
+	us2 = (const uchar_t *)s2;
+
+	while (cm[*us1] == cm[*us2++])
+		if (*us1++ == '\0')
+			return (0);
+	return (cm[*us1] - cm[*(us2 - 1)]);
+}
+
+int
+strcasecmp(const char *s1, const char *s2)
+{
+	/* would be nice to avoid uselocale()... but I don't see how */
+	return (strcasecmp_l(s1, s2, uselocale(NULL)));
+}
--- /dev/null	Tue May 20 07:58:48 2014
+++ new/usr/src/lib/libc/port/locale/strcasestr.c	Tue May 20 07:58:51 2014
@@ -0,0 +1,79 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+/*	Copyright (c) 1988 AT&T	*/
+/*	  All Rights Reserved  	*/
+
+#include "lint.h"
+#include <string.h>
+#include <ctype.h>
+#include <sys/types.h>
+#include <locale.h>
+#include "lctype.h"
+#include "localeimpl.h"
+
+/*
+ * strcasestr() locates the first occurrence in the string s1 of the
+ * sequence of characters (excluding the terminating null character)
+ * in the string s2, ignoring case.  strcasestr() returns a pointer
+ * to the located string, or a null pointer if the string is not found.
+ * If s2 is empty, the function returns s1.
+ */
+
+char *
+strcasestr_l(const char *s1, const char *s2, locale_t loc)
+{
+	const int *cm = loc->ctype->lc_trans_lower;
+	const uchar_t *us1 = (const uchar_t *)s1;
+	const uchar_t *us2 = (const uchar_t *)s2;
+	const uchar_t *tptr;
+	int c;
+
+	if (us2 == NULL || *us2 == '\0')
+		return ((char *)us1);
+
+	c = cm[*us2];
+	while (*us1 != '\0') {
+		if (c == cm[*us1++]) {
+			tptr = us1;
+			while (cm[c = *++us2] == cm[*us1++] && c != '\0')
+				continue;
+			if (c == '\0')
+				return ((char *)tptr - 1);
+			us1 = tptr;
+			us2 = (const uchar_t *)s2;
+			c = cm[*us2];
+		}
+	}
+
+	return (NULL);
+}
+
+char *
+strcasestr(const char *s1, const char *s2)
+{
+	return (strcasestr_l(s1, s2, uselocale(NULL)));
+}
--- old/usr/src/lib/libc/port/locale/strcoll.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/strcoll.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1995 Alex Tatmanjants <alex@elvisti.kiev.ua>
  *		at Electronni Visti IA, Kiev, Ukraine.
@@ -33,6 +34,8 @@
 #include <string.h>
 #include <errno.h>
 #include <wchar.h>
+#include <xlocale.h>
+#include "localeimpl.h"
 #include "collate.h"
 
 #define	ALLOCA_LIMIT	16
@@ -44,16 +47,20 @@
  * should check errno.
  */
 int
-strcoll(const char *s1, const char *s2)
+strcoll_l(const char *s1, const char *s2, locale_t loc)
 {
 	int ret;
 	wchar_t *t1 = NULL, *t2 = NULL;
 	wchar_t *w1 = NULL, *w2 = NULL;
 	size_t sz1, sz2;
+	const struct lc_collate *lcc = loc->collate;
 
-	if (_collate_load_error)
-		goto error;
+	mbstate_t mbs1 = { 0 };	/* initial states */
+	mbstate_t mbs2 = { 0 };
 
+	if (lcc->lc_is_posix)
+		return (strcmp(s1, s2));
+
 	sz1 = strlen(s1) + 1;
 	sz2 = strlen(s2) + 1;
 
@@ -82,13 +89,13 @@
 			goto error;
 	}
 
-	if ((mbstowcs(w1, s1, sz1)) == (size_t)-1)
+	if ((mbsrtowcs_l(w1, &s1, sz1, &mbs1, loc)) == (size_t)-1)
 		goto error;
 
-	if ((mbstowcs(w2, s2, sz2)) == (size_t)-1)
+	if ((mbsrtowcs_l(w2, &s2, sz2, &mbs2, loc)) == (size_t)-1)
 		goto error;
 
-	ret = wcscoll(w1, w2);
+	ret = wcscoll_l(w1, w2, loc);
 	if (t1)
 		free(t1);
 	if (t2)
@@ -102,4 +109,10 @@
 	if (t2)
 		free(t2);
 	return (strcmp(s1, s2));
+}
+
+int
+strcoll(const char *s1, const char *s2)
+{
+	return (strcoll_l(s1, s2, uselocale(NULL)));
 }
--- old/usr/src/lib/libc/port/locale/strfmon.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/strfmon.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2001 Alexey Zelkin <phantom@FreeBSD.org>
  * All rights reserved.
@@ -41,6 +42,9 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include "localeimpl.h"
+#include "lmonetary.h"
+#include "lnumeric.h"
 
 /* internal flags */
 #define	NEED_GROUPING		0x01	/* print digits grouped (default) */
@@ -60,7 +64,7 @@
 }
 
 #define	PRINTS(STR) {						\
-	char *tmps = STR;					\
+	const char *tmps = STR;					\
 	while (*tmps != '\0')					\
 		PRINT(*tmps++);					\
 }
@@ -87,22 +91,23 @@
 }
 
 #define	GRPSEP {						\
-	*--bufend = thousands_sep;				\
+	bufend -= thousands_len;				\
+	(void) memcpy(bufend, thousands_sep, thousands_len);	\
 	groups++;						\
 }
 
-static void __setup_vars(int, char *, char *, char *, char **);
-static int __calc_left_pad(int, char *);
-static char *__format_grouped_double(double, int *, int, int, int);
+static void setup_vars(const struct lc_monetary *, int, char *, char *, char *,
+    const char **);
+static int calc_left_pad(const struct lc_monetary *, int, const char *);
+static char *format_grouped_double(const struct lc_monetary *,
+    const struct lc_numeric *, double, int *, int, int, int);
 
 ssize_t
-strfmon(char *_RESTRICT_KYWD s, size_t maxsize,
-    const char *_RESTRICT_KYWD format, ...)
+strfmon_impl(char *_RESTRICT_KYWD s, size_t maxsize, locale_t loc,
+    const char *_RESTRICT_KYWD format, va_list ap)
 {
-	va_list		ap;
 	char 		*dst;		/* output destination pointer */
 	const char 	*fmt;		/* current format poistion pointer */
-	struct lconv 	*lc;		/* pointer to lconv structure */
 	char		*asciivalue;	/* formatted double pointer */
 
 	int		flags;		/* formatting options */
@@ -114,18 +119,20 @@
 	double		value;		/* just value */
 	char		space_char = ' '; /* space after currency */
 
-	char		cs_precedes;	/* values gathered from struct lconv */
+	char		cs_precedes;	/* values from struct lc_monetary */
 	char		sep_by_space;
 	char		sign_posn;
-	char		*signstr;
-	char		*currency_symbol;
+	const char	*signstr;
+	const char	*currency_symbol;
 
 	char		*tmpptr;	/* temporary vars */
 	int		sverrno;
+	const struct lc_monetary *lmon;		/* monetary structure */
+	const struct lc_numeric *lnum;		/* numeric structure */
 
-	va_start(ap, format);
+	lmon = loc->monetary;
+	lnum = loc->numeric;
 
-	lc = localeconv();
 	dst = s;
 	fmt = format;
 	asciivalue = NULL;
@@ -231,18 +238,14 @@
 				goto format_error;
 		}
 
-		if (currency_symbol != NULL)
-			free(currency_symbol);
 		if (flags & USE_INTL_CURRENCY) {
-			currency_symbol = strdup(lc->int_curr_symbol);
+			currency_symbol = lmon->int_curr_symbol;
+			/* by definition three letters followed by a space */
 			if (currency_symbol != NULL)
-				space_char = *(currency_symbol+3);
+				space_char = currency_symbol[3];
 		} else
-			currency_symbol = strdup(lc->currency_symbol);
+			currency_symbol = lmon->currency_symbol;
 
-		if (currency_symbol == NULL)
-			goto end_error;			/* ENOMEM. */
-
 		/* value itself */
 		value = va_arg(ap, double);
 
@@ -254,9 +257,9 @@
 
 		/* fill left_prec with amount of padding chars */
 		if (left_prec >= 0) {
-			pad_size = __calc_left_pad((flags ^ IS_NEGATIVE),
+			pad_size = calc_left_pad(lmon, (flags ^ IS_NEGATIVE),
 			    currency_symbol) -
-			    __calc_left_pad(flags, currency_symbol);
+			    calc_left_pad(lmon, flags, currency_symbol);
 			if (pad_size < 0)
 				pad_size = 0;
 		}
@@ -263,7 +266,7 @@
 
 		if (asciivalue != NULL)
 			free(asciivalue);
-		asciivalue = __format_grouped_double(value, &flags,
+		asciivalue = format_grouped_double(lmon, lnum, value, &flags,
 		    left_prec, right_prec, pad_char);
 		if (asciivalue == NULL)
 			goto end_error;		/* errno already set */
@@ -270,8 +273,8 @@
 						/* to ENOMEM by malloc() */
 
 		/* set some variables for later use */
-		__setup_vars(flags, &cs_precedes, &sep_by_space, &sign_posn,
-		    &signstr);
+		setup_vars(lmon, flags, &cs_precedes, &sep_by_space,
+		    &sign_posn, &signstr);
 
 		/*
 		 * Description of some LC_MONETARY's values:
@@ -315,7 +318,7 @@
 		if (cs_precedes == 1) {
 			if (sign_posn == 1 || sign_posn == 3) {
 				PRINTS(signstr);
-				if (sep_by_space == 2)		/* XXX: ? */
+				if (sep_by_space == 2)
 					PRINT(' ');
 			}
 
@@ -382,9 +385,7 @@
 	}
 
 	PRINT('\0');
-	va_end(ap);
 	free(asciivalue);
-	free(currency_symbol);
 	return (dst - s - 1);	/* size of put data except trailing '\0' */
 
 e2big_error:
@@ -398,45 +399,66 @@
 	sverrno = errno;
 	if (asciivalue != NULL)
 		free(asciivalue);
-	if (currency_symbol != NULL)
-		free(currency_symbol);
 	errno = sverrno;
-	va_end(ap);
 	return (-1);
 }
 
-static void
-__setup_vars(int flags, char *cs_precedes, char *sep_by_space,
-    char *sign_posn, char **signstr)
+ssize_t
+strfmon(char *_RESTRICT_KYWD s, size_t maxsize,
+    const char *_RESTRICT_KYWD format, ...)
 {
+	va_list ap;
+	ssize_t ret;
 
-	struct lconv *lc = localeconv();
+	va_start(ap, format);
+	ret = strfmon_impl(s, maxsize, uselocale(NULL), format, ap);
+	va_end(ap);
+	return (ret);
+}
 
+ssize_t
+strfmon_l(char *_RESTRICT_KYWD s, size_t maxsize, locale_t loc,
+    const char *_RESTRICT_KYWD format, ...)
+{
+	ssize_t ret;
+	va_list ap;
+	va_start(ap, format);
+	ret = strfmon_impl(s, maxsize, loc, format, ap);
+	va_end(ap);
+	return (ret);
+}
+
+static void
+setup_vars(const struct lc_monetary *lmon, int flags, char *cs_precedes,
+    char *sep_by_space, char *sign_posn, const char **signstr)
+{
 	if ((flags & IS_NEGATIVE) && (flags & USE_INTL_CURRENCY)) {
-		*cs_precedes = lc->int_n_cs_precedes;
-		*sep_by_space = lc->int_n_sep_by_space;
-		*sign_posn = (flags & PARENTH_POSN) ? 0 : lc->int_n_sign_posn;
-		*signstr = (lc->negative_sign[0] == '\0') ? "-"
-		    : lc->negative_sign;
+		*cs_precedes = lmon->int_n_cs_precedes[0];
+		*sep_by_space = lmon->int_n_sep_by_space[0];
+		*sign_posn = (flags & PARENTH_POSN) ? 0 :
+		    lmon->int_n_sign_posn[0];
+		*signstr = (lmon->negative_sign[0] == '\0') ? "-" :
+		    lmon->negative_sign;
 	} else if (flags & USE_INTL_CURRENCY) {
-		*cs_precedes = lc->int_p_cs_precedes;
-		*sep_by_space = lc->int_p_sep_by_space;
-		*sign_posn = (flags & PARENTH_POSN) ? 0 : lc->int_p_sign_posn;
-		*signstr = lc->positive_sign;
+		*cs_precedes = lmon->int_p_cs_precedes[0];
+		*sep_by_space = lmon->int_p_sep_by_space[0];
+		*sign_posn = (flags & PARENTH_POSN) ? 0 :
+		    lmon->int_p_sign_posn[0];
+		*signstr = lmon->positive_sign;
 	} else if (flags & IS_NEGATIVE) {
-		*cs_precedes = lc->n_cs_precedes;
-		*sep_by_space = lc->n_sep_by_space;
-		*sign_posn = (flags & PARENTH_POSN) ? 0 : lc->n_sign_posn;
-		*signstr = (lc->negative_sign[0] == '\0') ? "-"
-		    : lc->negative_sign;
+		*cs_precedes = lmon->n_cs_precedes[0];
+		*sep_by_space = lmon->n_sep_by_space[0];
+		*sign_posn = (flags & PARENTH_POSN) ? 0 : lmon->n_sign_posn[0];
+		*signstr = (lmon->negative_sign[0] == '\0') ? "-" :
+		    lmon->negative_sign;
 	} else {
-		*cs_precedes = lc->p_cs_precedes;
-		*sep_by_space = lc->p_sep_by_space;
-		*sign_posn = (flags & PARENTH_POSN) ? 0 : lc->p_sign_posn;
-		*signstr = lc->positive_sign;
+		*cs_precedes = lmon->p_cs_precedes[0];
+		*sep_by_space = lmon->p_sep_by_space[0];
+		*sign_posn = (flags & PARENTH_POSN) ? 0 : lmon->p_sign_posn[0];
+		*signstr = lmon->positive_sign;
 	}
 
-	/* Set defult values for unspecified information. */
+	/* Set default values for unspecified information. */
 	if (*cs_precedes != 0)
 		*cs_precedes = 1;
 	if (*sep_by_space == CHAR_MAX)
@@ -446,13 +468,14 @@
 }
 
 static int
-__calc_left_pad(int flags, char *cur_symb)
+calc_left_pad(const struct lc_monetary *lmon, int flags, const char *cur_symb)
 {
-
-	char cs_precedes, sep_by_space, sign_posn, *signstr;
+	char cs_precedes, sep_by_space, sign_posn;
+	const char *signstr;
 	int left_chars = 0;
 
-	__setup_vars(flags, &cs_precedes, &sep_by_space, &sign_posn, &signstr);
+	setup_vars(lmon, flags, &cs_precedes, &sep_by_space, &sign_posn,
+	    &signstr);
 
 	if (cs_precedes != 0) {
 		left_chars += strlen(cur_symb);
@@ -473,7 +496,7 @@
 }
 
 static int
-get_groups(int size, char *grouping)
+get_groups(int size, const char *grouping)
 {
 
 	int	chars = 0;
@@ -498,8 +521,9 @@
 
 /* convert double to ASCII */
 static char *
-__format_grouped_double(double value, int *flags,
-    int left_prec, int right_prec, int pad_char)
+format_grouped_double(const struct lc_monetary *lmon,
+    const struct lc_numeric *lnum,
+    double value, int *flags, int left_prec, int right_prec, int pad_char)
 {
 
 	char		*rslt;
@@ -512,21 +536,25 @@
 
 	int		padded;
 
-	struct lconv	*lc = localeconv();
-	char		*grouping;
-	char		decimal_point;
-	char		thousands_sep;
+	const char	*grouping;
+	const char	*decimal_point;
+	const char	*thousands_sep;
+	int		decimal_len;
+	int		thousands_len;
 
 	int groups = 0;
 
-	grouping = lc->mon_grouping;
-	decimal_point = *lc->mon_decimal_point;
-	if (decimal_point == '\0')
-		decimal_point = *lc->decimal_point;
-	thousands_sep = *lc->mon_thousands_sep;
-	if (thousands_sep == '\0')
-		thousands_sep = *lc->thousands_sep;
+	grouping = lmon->mon_grouping;
+	decimal_point = lmon->mon_decimal_point;
+	if (*decimal_point == '\0')
+		decimal_point = lnum->decimal_point;
+	thousands_sep = lmon->mon_thousands_sep;
+	if (*thousands_sep == '\0')
+		thousands_sep = lnum->thousands_sep;
 
+	decimal_len = strlen(decimal_point);	/* usually 1 */
+	thousands_len = strlen(thousands_sep);	/* 0 or 1 usually */
+
 	/* fill left_prec with default value */
 	if (left_prec == -1)
 		left_prec = 0;
@@ -534,9 +562,9 @@
 	/* fill right_prec with default value */
 	if (right_prec == -1) {
 		if (*flags & USE_INTL_CURRENCY)
-			right_prec = lc->int_frac_digits;
+			right_prec = lmon->int_frac_digits[0];
 		else
-			right_prec = lc->frac_digits;
+			right_prec = lmon->frac_digits[0];
 
 		if (right_prec == CHAR_MAX)	/* POSIX locale ? */
 			right_prec = 2;
@@ -552,7 +580,15 @@
 	if (avalue_size < 0)
 		return (NULL);
 
-	/* make sure that we've enough space for result string */
+	/*
+	 * Make sure that we've enough space for result string.
+	 * This assumes that digits take up at least much space as
+	 * grouping and radix characters.  The worst case currently known
+	 * is for Arabic, where two-byte UTF-8 sequences are used for both
+	 * decimal and thousands seperators, and groups can be a small as two
+	 * decimal digits.  This will do no worse than doubling the storage
+	 * requirement.
+	 */
 	bufsize = strlen(avalue)*2+1;
 	rslt = calloc(1, bufsize);
 	if (rslt == NULL) {
@@ -561,7 +597,7 @@
 	}
 	bufend = rslt + bufsize - 1;	/* reserve space for trailing '\0' */
 
-	/* skip spaces at beggining */
+	/* skip spaces at beginning */
 	padded = 0;
 	while (avalue[padded] == ' ') {
 		padded++;
@@ -572,12 +608,13 @@
 		bufend -= right_prec;
 		(void) memcpy(bufend, avalue + avalue_size+padded-right_prec,
 		    right_prec);
-		*--bufend = decimal_point;
-		avalue_size -= (right_prec + 1);
+		bufend -= decimal_len;
+		(void) memcpy(bufend, decimal_point, decimal_len);
+		avalue_size -= (right_prec + decimal_len);
 	}
 
 	if ((*flags & NEED_GROUPING) &&
-	    thousands_sep != '\0' &&	/* XXX: need investigation */
+	    thousands_len != 0 &&
 	    *grouping != CHAR_MAX &&
 	    *grouping > 0) {
 		while (avalue_size > (int)*grouping) {
--- old/usr/src/lib/libc/port/locale/strftime.c	Tue May 20 07:58:51 2014
+++ new/usr/src/lib/libc/port/locale/strftime.c	Tue May 20 07:58:51 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 1989 The Regents of the University of California.
  * All rights reserved.
@@ -22,11 +23,14 @@
 #include <sys/stat.h>
 #include <string.h>
 #include <stdio.h>
+#include <locale.h>
 #include "timelocal.h"
+#include "localeimpl.h"
 
 static char *_add(const char *, char *, const char *);
 static char *_conv(int, const char *, char *, const char *);
-static char *_fmt(const char *, const struct tm *, char *, const char * const);
+static char *_fmt(locale_t, const char *, const struct tm *, char *,
+    const char * const);
 static char *_yconv(int, int, int, int, char *, const char *);
 
 extern char *tzname[];
@@ -62,13 +66,14 @@
 
 
 size_t
-strftime(char *_RESTRICT_KYWD s, size_t maxsize,
-    const char *_RESTRICT_KYWD format, const struct tm *_RESTRICT_KYWD t)
+strftime_l(char *_RESTRICT_KYWD s, size_t maxsize,
+    const char *_RESTRICT_KYWD format, const struct tm *_RESTRICT_KYWD t,
+    locale_t loc)
 {
 	char *p;
 
 	tzset();
-	p = _fmt(((format == NULL) ? "%c" : format), t, s, s + maxsize);
+	p = _fmt(loc, ((format == NULL) ? "%c" : format), t, s, s + maxsize);
 	if (p == s + maxsize)
 		return (0);
 	*p = '\0';
@@ -75,11 +80,19 @@
 	return (p - s);
 }
 
+size_t
+strftime(char *_RESTRICT_KYWD s, size_t maxsize,
+    const char *_RESTRICT_KYWD format, const struct tm *_RESTRICT_KYWD t)
+{
+	return (strftime_l(s, maxsize, format, t, uselocale(NULL)));
+}
+
 static char *
-_fmt(const char *format, const struct tm *t, char *pt, const char * const ptlim)
+_fmt(locale_t loc, const char *format, const struct tm *t, char *pt,
+    const char * const ptlim)
 {
 	int Ealternative, Oalternative, PadIndex;
-	struct lc_time_T *tptr = __get_current_time_locale();
+	const struct lc_time *tptr = loc->time;
 
 #define	PADDING(x)	fmt_padding[x][PadIndex]
 
@@ -130,10 +143,10 @@
 				    pt, ptlim);
 				continue;
 			case 'c':
-				pt = _fmt(tptr->c_fmt, t, pt, ptlim);
+				pt = _fmt(loc, tptr->c_fmt, t, pt, ptlim);
 				continue;
 			case 'D':
-				pt = _fmt("%m/%d/%y", t, pt, ptlim);
+				pt = _fmt(loc, "%m/%d/%y", t, pt, ptlim);
 				continue;
 			case 'd':
 				pt = _conv(t->tm_mday,
@@ -163,7 +176,7 @@
 				    PADDING(PAD_FMT_SDAYOFMONTH), pt, ptlim);
 				continue;
 			case 'F':
-				pt = _fmt("%Y-%m-%d", t, pt, ptlim);
+				pt = _fmt(loc, "%Y-%m-%d", t, pt, ptlim);
 				continue;
 			case 'H':
 				pt = _conv(t->tm_hour, PADDING(PAD_FMT_HMS),
@@ -223,10 +236,10 @@
 				    tptr->pm : tptr->am, pt, ptlim);
 				continue;
 			case 'R':
-				pt = _fmt("%H:%M", t, pt, ptlim);
+				pt = _fmt(loc, "%H:%M", t, pt, ptlim);
 				continue;
 			case 'r':
-				pt = _fmt(tptr->ampm_fmt, t, pt, ptlim);
+				pt = _fmt(loc, tptr->ampm_fmt, t, pt, ptlim);
 				continue;
 			case 'S':
 				pt = _conv(t->tm_sec, PADDING(PAD_FMT_HMS),
@@ -245,7 +258,7 @@
 			}
 
 			case 'T':
-				pt = _fmt("%H:%M:%S", t, pt, ptlim);
+				pt = _fmt(loc, "%H:%M:%S", t, pt, ptlim);
 				continue;
 			case 't':
 				pt = _add("\t", pt, ptlim);
@@ -357,7 +370,7 @@
 				 * "date as dd-bbb-YYYY"
 				 * (ado, 1993-05-24)
 				 */
-				pt = _fmt("%e-%b-%Y", t, pt, ptlim);
+				pt = _fmt(loc, "%e-%b-%Y", t, pt, ptlim);
 				continue;
 			case 'W':
 				pt = _conv((t->tm_yday + DAYSPERWEEK -
@@ -371,10 +384,10 @@
 				pt = _conv(t->tm_wday, "%d", pt, ptlim);
 				continue;
 			case 'X':
-				pt = _fmt(tptr->X_fmt, t, pt, ptlim);
+				pt = _fmt(loc, tptr->X_fmt, t, pt, ptlim);
 				continue;
 			case 'x':
-				pt = _fmt(tptr->x_fmt, t, pt, ptlim);
+				pt = _fmt(loc, tptr->x_fmt, t, pt, ptlim);
 				continue;
 			case 'y':
 				pt = _yconv(t->tm_year, TM_YEAR_BASE, 0, 1,
@@ -438,7 +451,7 @@
 				}
 				continue;
 			case '+':
-				pt = _fmt(tptr->date_fmt, t, pt, ptlim);
+				pt = _fmt(loc, tptr->date_fmt, t, pt, ptlim);
 				continue;
 			case '-':
 				if (PadIndex != PAD_DEFAULT)
